/**
 * @license
 * Copyright (c) 2014, 2022, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","ojs/ojdataprovider","ojs/ojeventtarget","ojs/ojmap","ojs/ojcomponentcore"],function(t,e,a,s,i){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;
/**
     * @preserve Copyright 2013 jQuery Foundation and other contributors
     * Released under the MIT license.
     * http://jquery.org/license
     */
/**
     * @preserve Copyright 2013 jQuery Foundation and other contributors
     * Released under the MIT license.
     * http://jquery.org/license
     */
class r{constructor(){this.unsubmittedItems=new s,this.submittingItems=new s}addItem(e){const a=this.unsubmittedItems.get(e.metadata.key),s=this.submittingItems.get(e.metadata.key);if(a&&("add"===a.operation||"update"===a.operation)||s&&("add"===s.operation||"update"===s.operation))throw new Error("Cannot add item with same key as an item being added or updated");a&&"remove"===a.operation?a.item.data&&t.Object.compareValues(a.item.data,e.data)?this.unsubmittedItems.delete(e.metadata.key):this.unsubmittedItems.set(e.metadata.key,{operation:"update",item:e}):this.unsubmittedItems.set(e.metadata.key,{operation:"add",item:e})}removeItem(t){const e=this.unsubmittedItems.get(t.metadata.key),a=this.submittingItems.get(t.metadata.key);if(e&&"remove"===e.operation||a&&"remove"===a.operation)throw new Error("Cannot remove item with same key as an item being removed");e&&"add"===e.operation?this.unsubmittedItems.delete(t.metadata.key):(e&&e.operation,this.unsubmittedItems.set(t.metadata.key,{operation:"remove",item:t}))}updateItem(t){const e=this.unsubmittedItems.get(t.metadata.key),a=this.submittingItems.get(t.metadata.key);if(e&&"remove"===e.operation||a&&"remove"===a.operation)throw new Error("Cannot update item with same key as an item being removed");!e||"add"!==e.operation&&"update"!==e.operation?this.unsubmittedItems.set(t.metadata.key,{operation:"update",item:t}):this.unsubmittedItems.set(t.metadata.key,{operation:e.operation,item:t})}setItemStatus(t,e,a){const s=t.item.metadata.key;if("submitting"===e)this.unsubmittedItems.delete(s),this.submittingItems.set(s,t);else if("submitted"===e)this.submittingItems.delete(s);else if("unsubmitted"===e){let e;this.submittingItems.delete(s),e=a?{operation:t.operation,item:{data:t.item.data,metadata:{key:t.item.metadata.key,message:a}}}:t,this.unsubmittedItems.set(s,e)}}getUnsubmittedItems(){return this.unsubmittedItems}getSubmittingItems(){return this.submittingItems}isEmpty(){return 0===this.unsubmittedItems.size&&0===this.submittingItems.size}getItem(t){let e=this.unsubmittedItems.get(t);return e||(e=this.submittingItems.get(t)),e}}class d extends a.GenericEvent{constructor(t){const e={};e.detail=t,super("submittableChange",e)}}class n{constructor(t,e){this.dataProvider=t,this.options=e,this.AsyncIterable=class{constructor(t,e){this._parent=t,this._asyncIterator=e,this[Symbol.asyncIterator]=function(){return this._asyncIterator}}},this.AsyncIterator=class{constructor(t,e,a){this._parent=t,this._baseIterator=e,this._params=a,this.firstBaseKey=null,this.mergedAddKeySet=new Set,this.mergedItemArray=[],this.nextOffset=0,null==this._params&&(this._params={})}_fetchNext(){return this._baseIterator.next().then(t=>{!this.firstBaseKey&&t.value.metadata.length&&(this.firstBaseKey=t.value.metadata[0].key),t.value.fetchParameters&&t.value.fetchParameters.sortCriteria&&(this._parent.lastSortCriteria=t.value.fetchParameters.sortCriteria);const e=t.value.data.map((e,a)=>({data:t.value.data[a],metadata:t.value.metadata[a]}));this._parent._mergeEdits(e,this.mergedItemArray,this._params.filterCriterion,this._parent.lastSortCriteria,!0,this.mergedAddKeySet,t.done);let a=this.mergedItemArray.length-this.nextOffset;for(let t=this.nextOffset;t<this.mergedItemArray.length;t++){const e=this.mergedItemArray[t];this._parent._isItemRemoved(e.metadata.key)&&--a}const s=this._params||{};if((s.size&&a<s.size||null==s.size&&0===a)&&!t.done)return this._fetchNext();const i=[],r=[];let d;for(d=this.nextOffset;d<this.mergedItemArray.length;d++){++this.nextOffset;const t=this.mergedItemArray[d];if(!this._parent._isItemRemoved(t.metadata.key)&&(i.push(t.data),r.push(t.metadata),s.size&&i.length===s.size))break}return{done:t.done&&0===i.length,value:{fetchParameters:this._params,data:i,metadata:r}}})}next(){return this._fetchNext()}},this._addEventListeners(t),this.editBuffer=new r,this.lastSortCriteria=null,this.lastIterator=null}_fetchByKeysFromBuffer(t){const e=new s,a=new Set;return t.keys.forEach(t=>{const s=this.editBuffer.getItem(t);if(s)switch(s.operation){case"add":case"update":e.set(t,s.item)}else a.add(t)}),{results:e,unresolvedKeys:a}}_compareItem(t,e,a){for(const s of a){if(t[s.attribute]>e[s.attribute])return"ascending"===s.direction?1:-1;if(t[s.attribute]<e[s.attribute])return"ascending"===s.direction?-1:1}return 0}_insertAddEdits(t,e,a,s,i,r){t.forEach((t,d)=>{if("add"===t.operation&&!i.has(d)&&(!e||e.filter(t.item.data)))if(a&&a.length){let e=!1;for(let r=0;r<s.length;r++)if(this._compareItem(t.item.data,s[r].data,a)<0){s.splice(r,0,t.item),i.add(d),e=!0;break}!e&&r&&(s.push(t.item),i.add(d))}else s.push(t.item),i.add(d)})}_mergeAddEdits(t,e,a,s,i){this._insertAddEdits(this.editBuffer.getUnsubmittedItems(),t,e,a,s,i),this._insertAddEdits(this.editBuffer.getSubmittingItems(),t,e,a,s,i)}_mergeEdits(t,a,s,i,r,d,n){let o;s&&(o=s.filter?s:e.FilterFactory.getFilter({filterDef:s,filterOptions:this.options})),!r||i&&i.length||this._mergeAddEdits(o,i,a,d,n);for(const e of t){const t=this.editBuffer.getItem(e.metadata.key);t?"remove"===t.operation?a.push(e):"update"===t.operation&&(o&&!o.filter(t.item.data)||a.push(t.item)):a.push(e)}i&&i.length&&this._mergeAddEdits(o,i,a,d,n)}_fetchFromOffset(t,e){return this.dataProvider.fetchByOffset(t).then(a=>{if(!this.editBuffer.isEmpty()){const s=a.results;let i=null;i=a.fetchParameters&&a.fetchParameters.sortCriteria?a.fetchParameters.sortCriteria:t.sortCriteria,this._mergeEdits(s,e,t.filterCriterion,i,0===t.offset,new Set,a.done);let r=e.length;for(const t of e)this._isItemRemoved(t.metadata.key)&&--r;if((t.size&&r<t.size||null==t.size&&0===r)&&!a.done){const s={attributes:t.attributes,clientId:t.clientId,filterCriterion:t.filterCriterion,offset:t.offset+a.results.length,size:t.size,sortCriteria:t.sortCriteria};return this._fetchFromOffset(s,e)}for(let t=0;t<e.length;t++)this._isItemRemoved(e[t].metadata.key)&&(e.splice(t,1),--t);return t.size&&-1!=t.size&&e.length>t.size&&e.splice(t.size),{fetchParameters:t,results:e,done:a.done}}return a})}containsKeys(t){const e=this._fetchByKeysFromBuffer(t),a=e.unresolvedKeys,s=new Set;return e.results.forEach((t,e)=>{s.add(e)}),0===a.size?Promise.resolve({containsParameters:t,results:s}):this.dataProvider.containsKeys({attributes:t.attributes,keys:a,scope:t.scope}).then(e=>s.size>0?(e.results.forEach((t,e)=>{s.add(e)}),{containsParameters:t,results:s}):e)}fetchByKeys(t){const e=this._fetchByKeysFromBuffer(t),a=e.unresolvedKeys,s=e.results;return 0===a.size?Promise.resolve({fetchParameters:t,results:s}):this.dataProvider.fetchByKeys({attributes:t.attributes,keys:a,scope:t.scope}).then(e=>s.size>0?(e.results.forEach((t,e)=>{s.set(e,t)}),{fetchParameters:t,results:s}):e)}fetchByOffset(t){return this._fetchFromOffset(t,[])}fetchFirst(t){this.lastSortCriteria=t?t.sortCriteria:null;const e=this.dataProvider.fetchFirst(t)[Symbol.asyncIterator]();return this.lastIterator=new this.AsyncIterator(this,e,t),new this.AsyncIterable(this,this.lastIterator)}getCapability(t){return this.dataProvider.getCapability(t)}_calculateSizeChange(t){let e=0;return t.forEach((t,a)=>{"add"===t.operation?++e:"remove"===t.operation&&--e}),e}getTotalSize(){return this.dataProvider.getTotalSize().then(t=>(t>-1&&(t+=this._calculateSizeChange(this.editBuffer.getSubmittingItems()),t+=this._calculateSizeChange(this.editBuffer.getUnsubmittedItems())),t))}isEmpty(){const t=this.editBuffer.getUnsubmittedItems(),e=this.editBuffer.getSubmittingItems();t.forEach((t,e)=>{if("add"===t.operation||"update"===t.operation)return"no"}),e.forEach((t,e)=>{if("add"===t.operation||"update"===t.operation)return"no"});const a=this.dataProvider.isEmpty();return"no"===a&&(t.size>0||e.size>0)?"unknown":a}_isItemRemoved(t){const e=this.editBuffer.getItem(t);return null!=e&&"remove"===e.operation}_addToMergedArrays(t,e,a=null){let s=null;if(this.lastIterator){const i=this.lastSortCriteria;if(i&&i.length){const e=this.lastIterator.mergedItemArray;for(let a=0;a<e.length;a++)if(this._compareItem(t.data,e[a].data,i)<0&&!this._isItemRemoved(e[a].metadata.key)){s=e[a].metadata.key,e.splice(a,0,t),a<this.lastIterator.nextOffset&&++this.lastIterator.nextOffset;break}}else s=e?this._getNextKey(a):this.lastIterator.firstBaseKey}return s}_getNextKey(t){let e=t;if(this.lastIterator){const a=this.lastIterator.mergedItemArray;let s=this._findKeyInItems(t,a);for(;e&&this._isItemRemoved(e);)e=-1===s||s+1===a.length?null:a[s+1].metadata.key,s++}return e}addItem(t){this.editBuffer.addItem(t);const a=this._addToMergedArrays(t,!1),s={add:{data:[t.data],keys:(new Set).add(t.metadata.key),metadata:[t.metadata],addBeforeKeys:[a]}},i=new e.DataProviderMutationEvent(s);this.dispatchEvent(i),this._dispatchSubmittableChangeEvent()}_removeFromMergedArrays(e,a){if(this.lastIterator){const s=this.lastIterator.mergedItemArray,i=this.lastIterator.mergedAddKeySet,r=this._findKeyInItems(e,s);if(-1!==r&&(a||i.has(e)?(s.splice(r,1),i.delete(e),r<this.lastIterator.nextOffset&&--this.lastIterator.nextOffset):r===this.lastIterator.nextOffset-1&&--this.lastIterator.nextOffset,t.KeyUtils.equals(this.lastIterator.firstBaseKey,e)&&(this.lastIterator.firstBaseKey=null,s.length>r)))for(let t=r;t<s.length;t++){const e=s[t].metadata.key;if(!this._isItemRemoved(e)){this.lastIterator.firstBaseKey=e;break}}}}removeItem(t){this.editBuffer.removeItem(t),this._removeFromMergedArrays(t.metadata.key,!1);const a={remove:{data:t.data?[t.data]:null,keys:(new Set).add(t.metadata.key),metadata:[t.metadata]}},s=new e.DataProviderMutationEvent(a);this.dispatchEvent(s),this._dispatchSubmittableChangeEvent()}updateItem(t){this.editBuffer.updateItem(t);const a={update:{data:[t.data],keys:(new Set).add(t.metadata.key),metadata:[t.metadata]}},s=new e.DataProviderMutationEvent(a);this.dispatchEvent(s),this._dispatchSubmittableChangeEvent()}getSubmittableItems(){const t=this.editBuffer.getUnsubmittedItems(),e=this.editBuffer.getSubmittingItems(),a=[];return t.forEach((t,s)=>{e.has(s)||a.push(t)}),a}resetAllUnsubmittedItems(){this.editBuffer.getUnsubmittedItems().clear(),this._dispatchSubmittableChangeEvent(),this.dispatchEvent(new e.DataProviderRefreshEvent)}_addEventDetail(t,e,a,s){null==t[e]&&(t[e]="add"===e?{data:[],keys:new Set,metadata:[],addBeforeKeys:[]}:{data:[],keys:new Set,metadata:[]}),t[e].keys.add(a.metadata.key),t[e].data.push(a.data),t[e].metadata.push(a.metadata),"add"===e&&t[e].addBeforeKeys.push(s)}resetUnsubmittedItem(t){const a=this.editBuffer.getUnsubmittedItems(),i=new Set,r=new s,d=a.get(t);d&&(i.add(t),r.set(t,d),a.delete(t)),this._dispatchSubmittableChangeEvent(),this.dataProvider.fetchByKeys({keys:i}).then(t=>{const a={};let s;r.forEach((e,i)=>{if("add"===e.operation)this._removeFromMergedArrays(e.item.metadata.key,!1),this._addEventDetail(a,"remove",e.item);else if("remove"===e.operation){if(s=t.results.get(i),s){let t=null;if(this.lastIterator){const e=this.lastIterator.mergedItemArray,a=this._findKeyInItems(i,e);if(-1!==a)for(let s=a+1;s<e.length;s++)if(!this._isItemRemoved(e[s].metadata.key)){t=e[s].metadata.key;break}}this._addEventDetail(a,"add",s,t)}}else s=t.results.get(i),s?this._addEventDetail(a,"update",s):this._addEventDetail(a,"remove",e.item)}),this.dispatchEvent(new e.DataProviderMutationEvent(a))})}setItemStatus(t,e,a){t&&(this.editBuffer.setItemStatus(t,e,a),this._dispatchSubmittableChangeEvent())}_dispatchSubmittableChangeEvent(){const t=this.getSubmittableItems(),e=new d(t);this.dispatchEvent(e)}_findKeyInMetadata(e,a){if(a)for(let s=0;s<a.length;s++)if(t.KeyUtils.equals(e,a[s].key))return s;return-1}_findKeyInItems(e,a){if(a)for(let s=0;s<a.length;s++)if(t.KeyUtils.equals(e,a[s].metadata.key))return s;return-1}_initDetailProp(t,e,a,s){t[a]&&(e[a]=s)}_initDetail(t,e,a,s=!1){a?(this._initDetailProp(t,e,"data",[]),this._initDetailProp(t,e,"metadata",[]),s&&this._initDetailProp(t,e,"addBeforeKeys",[]),this._initDetailProp(t,e,"parentKeys",[])):(this._initDetailProp(t,e,"data",t.data),this._initDetailProp(t,e,"metadata",t.metadata),s&&this._initDetailProp(t,e,"addBeforeKeys",t.addBeforeKeys),this._initDetailProp(t,e,"parentKeys",t.parentKeys))}_initDetails(t,e,a){t.add&&(e.add={keys:new Set},this._initDetail(t.add,e.add,a,!0)),t.remove&&(e.remove={keys:new Set},this._initDetail(t.remove,e.remove,a)),t.update&&(e.update={keys:new Set},this._initDetail(t.update,e.update,a))}_pushDetailProp(t,e,a,s){t[a]&&e[a].push(t[a][s])}_pushDetail(t,e,a){if(a.keys.add(t),e.metadata){const s=this._findKeyInMetadata(t,e.metadata);s>-1&&(this._pushDetailProp(e,a,"data",s),this._pushDetailProp(e,a,"metadata",s),a.addBeforeKeys&&this._pushDetailProp(e,a,"addBeforeKeys",s),this._pushDetailProp(e,a,"parentKeys",s))}}_isSkipItem(t,e,a){let s=null!=e.get(t);if(!s){const e=a.get(t);s=e&&"remove"===e.operation}return s}_isSortFieldUpdated(t,e){let a=!1;if(this.lastIterator&&this.lastSortCriteria&&this.lastSortCriteria.length){const s=this._findKeyInItems(t,this.lastIterator.mergedItemArray),i=[];let r=0;if(this.lastIterator&&this.lastSortCriteria)for(const t of this.lastSortCriteria)i[r++]=t.attribute;for(const r of i){const i=this._findKeyInMetadata(t,e.metadata);this.lastIterator.mergedItemArray[s][r]!==e.data[i]&&(a=!0)}}return a}_getOperationDetails(t,e,a){if(t&&(t.add||t.remove||t.update)){let s={};const i=this.editBuffer.getSubmittingItems(),r=this.editBuffer.getUnsubmittedItems();if(0===i.size&&0===r.size)s=t;else{let d;if(this._initDetails(t,s,!0),t.add&&t.add.keys.forEach(e=>{if(this.lastIterator&&this.lastSortCriteria&&0!==this.lastSortCriteria.length)d=this._isSkipItem(e,i,r),d||this._pushDetail(e,t.add,s.add);else{let a=s.remove;a||(a={keys:new Set,data:[],metadata:[]},s.remove=a);const d=i.get(e),n=r.get(e),o=d||n;o&&(a.keys.add(o.item.metadata.key),a.data.push(o.item.data),a.metadata.push(o.item.metadata)),s.remove=a;let m=s.add;m||(m={keys:new Set,data:[],metadata:[],addBeforeKeys:[]},s.add=m),this._pushDetail(e,t.add,s.add)}}),t.remove&&t.remove.keys.forEach(e=>{d=this._isSkipItem(e,i,r),d||this._pushDetail(e,t.remove,s.remove);const a=r.get(e);!a||"remove"!==a.operation&&"update"!==a.operation||r.delete(e)}),t.update){let n=0;t.update.keys.forEach(o=>{if(a[n]&&this.lastIterator&&this.lastSortCriteria&&this.lastSortCriteria.length){let t=s.remove;t||(t={keys:new Set,data:[],metadata:[]},s.remove=t);const a=i.get(o),d=r.get(o),m=a||d;m&&(t.keys.add(m.item.metadata.key),t.data.push(m.item.data),t.metadata.push(m.item.metadata));let h=s.add;h||(h={keys:new Set,data:[],metadata:[],addBeforeKeys:[]},s.add=h),m&&(h.keys.add(m.item.metadata.key),h.data.push(m.item.data),h.metadata.push(m.item.metadata),h.addBeforeKeys.push(e[n]),n++)}else d=this._isSkipItem(o,i,r),d||this._pushDetail(o,t.update,s.update)})}}return s}return t}_handleRefreshEvent(t){const e=this.editBuffer.getUnsubmittedItems(),a=new Set;e.forEach(t=>{"remove"!==t.operation&&"update"!==t.operation||a.add(t.item.metadata.key)}),a.size>0?this.dataProvider.fetchByKeys({keys:a}).then(s=>{s.results.forEach((t,e)=>{a.delete(e)}),a.forEach(t=>{e.delete(t)}),this.dispatchEvent(t)}):this.dispatchEvent(t)}_handleMutateEvent(t){const a=t.detail.add;a&&a.metadata&&a.data&&a.metadata.forEach((t,e)=>{const s=this._addToMergedArrays({metadata:a.metadata[e],data:a.data[e]},!0,a.addBeforeKeys[e]);a.addBeforeKeys[e]&&!s&&this.lastIterator&&this.lastIterator.mergedItemArray&&this.lastIterator.mergedItemArray.splice(this.lastIterator.mergedItemArray.length,0,{data:a.data[e],metadata:a.metadata[e]}),a.addBeforeKeys[e]=s});const s=t.detail.remove;s&&s.keys.forEach(t=>{this._removeFromMergedArrays(t,!0)});const i=[],r=[],d=t.detail.update;d&&d.data.forEach((t,e)=>{r[e]=this._isSortFieldUpdated(d.metadata[e].key,d),r[e]&&(this._removeFromMergedArrays(d.metadata[e].key,!0),i[e]=this._addToMergedArrays({data:t,metadata:d.metadata[e]},!0),i[e]||this.lastIterator&&this.lastIterator.mergedItemArray&&this.lastIterator.mergedItemArray.splice(this.lastIterator.mergedItemArray.length,0,{data:t,metadata:d.metadata[e]}))});const n=this._getOperationDetails(t.detail,i,r);this.dispatchEvent(new e.DataProviderMutationEvent(n))}_addEventListeners(t){t[n._ADDEVENTLISTENER](n._REFRESH,this._handleRefreshEvent.bind(this)),t[n._ADDEVENTLISTENER](n._MUTATE,this._handleMutateEvent.bind(this))}}return n._REFRESH="refresh",n._MUTATE="mutate",n._ADDEVENTLISTENER="addEventListener",a.EventTargetMixin.applyMixin(n),t._registerLegacyNamespaceProp("BufferingDataProvider",n),n});
//# sourceMappingURL=ojbufferingdataprovider.js.map