/**
 * @license
 * Copyright (c) 2014, 2022, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","ojs/ojdvt-base","ojs/ojcomponentcore","jquery","ojs/ojconverterutils-i18n","ojs/ojconverter-number","ojs/ojlogger","ojs/ojchart-toolkit"],function(e,t,r,n,o,i,a,s){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n;var l={properties:{animationOnDataChange:{type:"string",enumValues:["auto","none","slideToLeft","slideToRight"],value:"none"},animationOnDisplay:{type:"string",enumValues:["alphaFade","auto","none","zoom"],value:"none"},as:{type:"string",value:""},coordinateSystem:{type:"string",enumValues:["cartesian","polar"],value:"cartesian"},data:{type:"object",extension:{webelement:{exceptionStatus:[{type:"deprecated",since:"11.0.0",description:"Data sets from a DataProvider cannot be sent to WebDriverJS; use ViewModels or page variables instead."}]}}},dataCursor:{type:"string",enumValues:["auto","off","on"],value:"auto"},dataCursorBehavior:{type:"string",enumValues:["auto","smooth","snap"],value:"auto"},dataCursorPosition:{type:"object",writeback:!0,properties:{x:{type:"number|string"},y:{type:"number"},y2:{type:"number"}}},dataLabel:{type:"function"},dnd:{type:"object",properties:{drag:{type:"object",properties:{groups:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},drag:{type:"function"},dragEnd:{type:"function"},dragStart:{type:"function"}}},items:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},drag:{type:"function"},dragEnd:{type:"function"},dragStart:{type:"function"}}},series:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},drag:{type:"function"},dragEnd:{type:"function"},dragStart:{type:"function"}}}}},drop:{type:"object",properties:{legend:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}},plotArea:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}},xAxis:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}},y2Axis:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}},yAxis:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}}}}}},dragMode:{type:"string",enumValues:["off","pan","select","user","zoom"],value:"user"},drilling:{type:"string",enumValues:["groupsOnly","off","on","seriesOnly"],value:"off"},groupComparator:{type:"function"},groups:{type:"Array<string>|Array<Object>|Promise"},hiddenCategories:{type:"Array<string>",writeback:!0,value:[]},hideAndShowBehavior:{type:"string",enumValues:["none","withRescale","withoutRescale"],value:"none"},highlightMatch:{type:"string",enumValues:["all","any"],value:"all"},highlightedCategories:{type:"Array<string>",writeback:!0,value:[]},hoverBehavior:{type:"string",enumValues:["dim","none"],value:"none"},initialZooming:{type:"string",enumValues:["first","last","none"],value:"none"},legend:{type:"object",properties:{backgroundColor:{type:"string"},borderColor:{type:"string"},maxSize:{type:"string"},position:{type:"string",enumValues:["auto","bottom","end","start","top"],value:"auto"},referenceObjectSection:{type:"object",properties:{title:{type:"string"},titleHalign:{type:"string",enumValues:["center","end","start"],value:"start"},titleStyle:{type:"object",value:{}}}},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"},scrolling:{type:"string",enumValues:["asNeeded","off"],value:"asNeeded"},sections:{type:"Array<Object>",value:[]},seriesSection:{type:"object",properties:{title:{type:"string"},titleHalign:{type:"string",enumValues:["center","end","start"],value:"start"},titleStyle:{type:"object",value:{}}}},size:{type:"string"},symbolHeight:{type:"number"},symbolWidth:{type:"number"},textStyle:{type:"object",value:{}},title:{type:"string"},titleHalign:{type:"string",enumValues:["center","end","start"],value:"start"},titleStyle:{type:"object",value:{}}}},multiSeriesDrilling:{type:"string",enumValues:["off","on"],value:"off"},orientation:{type:"string",enumValues:["horizontal","vertical"],value:"vertical"},otherThreshold:{type:"number",value:0},overview:{type:"object",properties:{content:{type:"object",value:{}},height:{type:"string"},rendered:{type:"string",enumValues:["off","on"],value:"off"}}},pieCenter:{type:"object",properties:{converter:{type:"object"},label:{type:"number|string"},labelStyle:{type:"object",value:{}},renderer:{type:"function"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"}}},plotArea:{type:"object",properties:{backgroundColor:{type:"string"},borderColor:{type:"string"},borderWidth:{type:"number"},rendered:{type:"string",enumValues:["off","on"],value:"on"}}},polarGridShape:{type:"string",enumValues:["circle","polygon"],value:"circle"},selection:{type:"Array<any>",writeback:!0,value:[]},selectionMode:{type:"string",enumValues:["multiple","none","single"],value:"none"},series:{type:"Array<Object>|Promise"},seriesComparator:{type:"function"},sorting:{type:"string",enumValues:["ascending","descending","off"],value:"off"},splitDualY:{type:"string",enumValues:["auto","off","on"],value:"auto"},splitterPosition:{type:"number",value:.5},stack:{type:"string",enumValues:["off","on"],value:"off"},stackLabel:{type:"string",enumValues:["off","on"],value:"off"},stackLabelProvider:{type:"function"},styleDefaults:{type:"object",properties:{animationDownColor:{type:"string"},animationDuration:{type:"number"},animationIndicators:{type:"string",enumValues:["all","none"],value:"all"},animationUpColor:{type:"string"},barGapRatio:{type:"number"},borderColor:{type:"string"},borderWidth:{type:"number"},boxPlot:{type:"object",properties:{medianSvgClassName:{type:"string",value:""},medianSvgStyle:{type:"object",value:{}},whiskerEndLength:{type:"string"},whiskerEndSvgClassName:{type:"string",value:""},whiskerEndSvgStyle:{type:"object",value:{}},whiskerSvgClassName:{type:"string",value:""},whiskerSvgStyle:{type:"object",value:{}}}},colors:{type:"Array<string>"},dataCursor:{type:"object",properties:{lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},markerColor:{type:"string"},markerDisplayed:{type:"string",enumValues:["off","on"],value:"on"},markerSize:{type:"number"}}},dataItemGaps:{type:"string"},dataLabelCollision:{type:"string",enumValues:["fitInBounds","none"],value:"none"},dataLabelPosition:{type:"string|Array<string>",enumValues:["aboveMarker","afterMarker","auto","beforeMarker","belowMarker","center","insideBarEdge","none","outsideBarEdge","outsideSlice"],value:"auto"},dataLabelStyle:{type:"object|Array<Object>"},funnelBackgroundColor:{type:"string"},groupSeparators:{type:"object",properties:{color:{type:"string"},rendered:{type:"string",enumValues:["auto","off"],value:"auto"}}},hoverBehaviorDelay:{type:"number"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineType:{type:"string",enumValues:["auto","centeredSegmented","centeredStepped","curved","none","segmented","stepped","straight"],value:"auto"},lineWidth:{type:"number"},markerColor:{type:"string"},markerDisplayed:{type:"string",enumValues:["auto","off","on"],value:"auto"},markerShape:{type:"string",value:"auto"},markerSize:{type:"number"},marqueeBorderColor:{type:"string"},marqueeColor:{type:"string"},maxBarWidth:{type:"number"},otherColor:{type:"string"},patterns:{type:"Array<string>"},pieFeelerColor:{type:"string"},pieInnerRadius:{type:"number",value:0},selectionEffect:{type:"string",enumValues:["explode","highlight","highlightAndExplode"],value:"highlight"},seriesEffect:{type:"string",enumValues:["color","gradient","pattern"],value:"color"},shapes:{type:"Array<string>"},stackLabelStyle:{type:"object",value:{}},stockFallingColor:{type:"string"},stockRangeColor:{type:"string"},stockRisingColor:{type:"string"},stockVolumeColor:{type:"string"},threeDEffect:{type:"string",enumValues:["off","on"],value:"off"},tooltipLabelStyle:{type:"object",value:{}},tooltipValueStyle:{type:"object",value:{}}}},timeAxisType:{type:"string",enumValues:["auto","disabled","enabled","mixedFrequency","skipGaps"],value:"auto"},tooltip:{type:"object",properties:{renderer:{type:"function"}}},touchResponse:{type:"string",enumValues:["auto","touchStart"],value:"auto"},trackResize:{type:"string",enumValues:["off","on"],value:"on"},translations:{type:"object",value:{},properties:{componentName:{type:"string"},labelAndValue:{type:"string"},labelClearSelection:{type:"string"},labelClose:{type:"string"},labelCountWithTotal:{type:"string"},labelDataVisualization:{type:"string"},labelDate:{type:"string"},labelDefaultGroupName:{type:"string"},labelGroup:{type:"string"},labelHigh:{type:"string"},labelInvalidData:{type:"string"},labelLow:{type:"string"},labelNoData:{type:"string"},labelOpen:{type:"string"},labelOther:{type:"string"},labelPercentage:{type:"string"},labelQ1:{type:"string"},labelQ2:{type:"string"},labelQ3:{type:"string"},labelSeries:{type:"string"},labelTargetValue:{type:"string"},labelValue:{type:"string"},labelVolume:{type:"string"},labelX:{type:"string"},labelY:{type:"string"},labelZ:{type:"string"},stateCollapsed:{type:"string"},stateDrillable:{type:"string"},stateExpanded:{type:"string"},stateHidden:{type:"string"},stateIsolated:{type:"string"},stateMaximized:{type:"string"},stateMinimized:{type:"string"},stateSelected:{type:"string"},stateUnselected:{type:"string"},stateVisible:{type:"string"},tooltipPan:{type:"string"},tooltipSelect:{type:"string"},tooltipZoom:{type:"string"}}},type:{type:"string",enumValues:["area","bar","boxPlot","bubble","combo","funnel","line","lineWithArea","pie","pyramid","scatter","stock"],value:"bar"},valueFormats:{type:"object",properties:{close:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},group:{type:"object",properties:{tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string|Array<string>"}}},high:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},label:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"}}},low:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},open:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},q1:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},q2:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},q3:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},series:{type:"object",properties:{tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},targetValue:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},value:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},volume:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},x:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},y:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},y2:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}},z:{type:"object",properties:{converter:{type:"object"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},tooltipDisplay:{type:"string",enumValues:["auto","off"],value:"auto"},tooltipLabel:{type:"string"}}}}},xAxis:{type:"object",properties:{axisLine:{type:"object",properties:{lineColor:{type:"string"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},baselineScaling:{type:"string",enumValues:["min","zero"],value:"zero"},dataMax:{type:"number"},dataMin:{type:"number"},majorTick:{type:"object",properties:{baselineColor:{type:"string",value:"auto"},baselineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},baselineWidth:{type:"number"},lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},max:{type:"number|string"},maxSize:{type:"string"},min:{type:"number|string"},minStep:{type:"number"},minorStep:{type:"number"},minorTick:{type:"object",properties:{lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},referenceObjects:{type:"Array<Object>",value:[]},rendered:{type:"string",enumValues:["off","on"],value:"on"},scale:{type:"string",enumValues:["linear","log"],value:"linear"},size:{type:"string"},step:{type:"number"},tickLabel:{type:"object",properties:{converter:{type:"object"},rendered:{type:"string",enumValues:["off","on"],value:"on"},rotation:{type:"string",enumValues:["auto","none"],value:"auto"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},style:{type:"object",value:{}}}},title:{type:"string"},titleStyle:{type:"object",value:{}},viewportEndGroup:{type:"number|string"},viewportMax:{type:"number|string"},viewportMin:{type:"number|string"},viewportStartGroup:{type:"number|string"}}},y2Axis:{type:"object",properties:{alignTickMarks:{type:"string",enumValues:["off","on"],value:"on"},axisLine:{type:"object",properties:{lineColor:{type:"string"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},baselineScaling:{type:"string",enumValues:["min","zero"],value:"zero"},dataMax:{type:"number"},dataMin:{type:"number"},majorTick:{type:"object",properties:{baselineColor:{type:"string",value:"auto"},baselineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},baselineWidth:{type:"number"},lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},max:{type:"number"},maxSize:{type:"string"},min:{type:"number"},minStep:{type:"number"},minorStep:{type:"number"},minorTick:{type:"object",properties:{lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},position:{type:"string",enumValues:["auto","bottom","end","start","top"],value:"auto"},referenceObjects:{type:"Array<Object>",value:[]},rendered:{type:"string",enumValues:["off","on"],value:"on"},scale:{type:"string",enumValues:["linear","log"],value:"linear"},size:{type:"string"},step:{type:"number"},tickLabel:{type:"object",properties:{converter:{type:"object"},position:{type:"string",enumValues:["inside","outside"],value:"outside"},rendered:{type:"string",enumValues:["off","on"],value:"on"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},style:{type:"object",value:{}}}},title:{type:"string"},titleStyle:{type:"object",value:{}}}},yAxis:{type:"object",properties:{axisLine:{type:"object",properties:{lineColor:{type:"string"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},baselineScaling:{type:"string",enumValues:["min","zero"],value:"zero"},dataMax:{type:"number"},dataMin:{type:"number"},majorTick:{type:"object",properties:{baselineColor:{type:"string",value:"auto"},baselineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},baselineWidth:{type:"number"},lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},max:{type:"number"},maxSize:{type:"string"},min:{type:"number"},minStep:{type:"number"},minorStep:{type:"number"},minorTick:{type:"object",properties:{lineColor:{type:"string"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineWidth:{type:"number"},rendered:{type:"string",enumValues:["auto","off","on"],value:"auto"}}},position:{type:"string",enumValues:["auto","bottom","end","start","top"],value:"auto"},referenceObjects:{type:"Array<Object>",value:[]},rendered:{type:"string",enumValues:["off","on"],value:"on"},scale:{type:"string",enumValues:["linear","log"],value:"linear"},size:{type:"string"},step:{type:"number"},tickLabel:{type:"object",properties:{converter:{type:"object"},position:{type:"string",enumValues:["inside","outside"],value:"outside"},rendered:{type:"string",enumValues:["off","on"],value:"on"},scaling:{type:"string",enumValues:["auto","billion","million","none","quadrillion","thousand","trillion"],value:"auto"},style:{type:"object",value:{}}}},title:{type:"string"},titleStyle:{type:"object",value:{}},viewportMax:{type:"number"},viewportMin:{type:"number"}}},zoomAndScroll:{type:"string",enumValues:["delayed","delayedScrollOnly","live","liveScrollOnly","off"],value:"off"},zoomDirection:{type:"string",enumValues:["auto","x","y"],value:"auto"}},methods:{getContextByNode:{},getDataItem:{},getGroup:{},getGroupCount:{},getLegend:{},getPlotArea:{},getProperty:{},getSeries:{},getSeriesCount:{},getValuesAt:{},getXAxis:{},getY2Axis:{},getYAxis:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojDrill:{},ojGroupDrill:{},ojItemDrill:{},ojMultiSeriesDrill:{},ojSelectInput:{},ojSeriesDrill:{},ojViewportChange:{},ojViewportChangeInput:{}},extension:{}};!function(){l.extension._WIDGET_NAME="ojChart";var r=t.shapeParseFunction({"style-defaults.marker-shape":!0},{square:!0,circle:!0,diamond:!0,plus:!0,triangleDown:!0,triangleUp:!0,human:!0,star:!0,auto:!0});e.CustomElementBridge.register("oj-chart",{metadata:l,parseFunction:function(e,t,n,o){return"number|string"===n.type?isNaN(e)?e:Number(e):"style-defaults.data-label-style"===t?JSON.parse(e):r(e,t,n,o)}})}();var p={properties:{borderColor:{type:"string"},borderWidth:{type:"number"},boxPlot:{type:"object",properties:{medianSvgClassName:{type:"string"},medianSvgStyle:{type:"object"},q2Color:{type:"string"},q2SvgClassName:{type:"string"},q2SvgStyle:{type:"object"},q3Color:{type:"string"},q3SvgClassName:{type:"string"},q3SvgStyle:{type:"object"},whiskerEndLength:{type:"string"},whiskerEndSvgClassName:{type:"string"},whiskerEndSvgStyle:{type:"object"},whiskerSvgClassName:{type:"string"},whiskerSvgStyle:{type:"object"}}},categories:{type:"Array<string>"},close:{type:"number"},color:{type:"string"},drilling:{type:"string",enumValues:["inherit","off","on"],value:"inherit"},groupId:{type:"Array<(string|number)>"},high:{type:"number"},items:{type:"Array<Object>|Array<number>"},label:{type:"string|Array<string>"},labelPosition:{type:"string|Array<string>",enumValues:["aboveMarker","afterMarker","auto","beforeMarker","belowMarker","center","insideBarEdge","none","outsideBarEdge","outsideSlice"]},labelStyle:{type:"object|Array<Object>"},low:{type:"number"},markerDisplayed:{type:"string",enumValues:["auto","off","on"]},markerShape:{type:"string"},markerSize:{type:"number"},open:{type:"number"},pattern:{type:"string",enumValues:["auto","largeChecker","largeCrosshatch","largeDiagonalLeft","largeDiagonalRight","largeDiamond","largeTriangle","smallChecker","smallCrosshatch","smallDiagonalLeft","smallDiagonalRight","smallDiamond","smallTriangle"],value:"auto"},q1:{type:"number"},q2:{type:"number"},q3:{type:"number"},seriesId:{type:"string|number"},shortDesc:{type:"string|function"},source:{type:"string"},sourceHover:{type:"string"},sourceHoverSelected:{type:"string"},sourceSelected:{type:"string"},svgClassName:{type:"string"},svgStyle:{type:"object"},targetValue:{type:"number"},value:{type:"number"},volume:{type:"number"},x:{type:"number|string"},y:{type:"number"},z:{type:"number"}},extension:{}};!function(){p.extension._CONSTRUCTOR=function(){};e.CustomElementBridge.register("oj-chart-item",{metadata:p,parseFunction:t.shapeParseFunction({"marker-shape":!0},{square:!0,circle:!0,diamond:!0,plus:!0,triangleDown:!0,triangleUp:!0,human:!0,star:!0,auto:!0})})}();var u={properties:{areaColor:{type:"string"},areaSvgClassName:{type:"string"},areaSvgStyle:{type:"object"},assignedToY2:{type:"string",enumValues:["off","on"],value:"off"},borderColor:{type:"string"},borderWidth:{type:"number"},boxPlot:{type:"object",properties:{medianSvgClassName:{type:"string"},medianSvgStyle:{type:"object"},q2Color:{type:"string"},q2SvgClassName:{type:"string"},q2SvgStyle:{type:"object"},q3Color:{type:"string"},q3SvgClassName:{type:"string"},q3SvgStyle:{type:"object"},whiskerEndLength:{type:"string"},whiskerEndSvgClassName:{type:"string"},whiskerEndSvgStyle:{type:"object"},whiskerSvgClassName:{type:"string"},whiskerSvgStyle:{type:"object"}}},categories:{type:"Array<string>"},color:{type:"string"},displayInLegend:{type:"string",enumValues:["auto","off","on"],value:"auto"},drilling:{type:"string",enumValues:["inherit","off","on"],value:"inherit"},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"]},lineType:{type:"string",enumValues:["auto","centeredSegmented","centeredStepped","curved","none","segmented","stepped","straight"]},lineWidth:{type:"number"},markerColor:{type:"string"},markerDisplayed:{type:"string",enumValues:["auto","off","on"]},markerShape:{type:"string"},markerSize:{type:"number"},markerSvgClassName:{type:"string"},markerSvgStyle:{type:"object"},name:{type:"string"},pattern:{type:"string",enumValues:["auto","largeChecker","largeCrosshatch","largeDiagonalLeft","largeDiagonalRight","largeDiamond","largeTriangle","smallChecker","smallCrosshatch","smallDiagonalLeft","smallDiagonalRight","smallDiamond","smallTriangle"],value:"auto"},pieSliceExplode:{type:"number",value:0},shortDesc:{type:"string"},source:{type:"string"},sourceHover:{type:"string"},sourceHoverSelected:{type:"string"},sourceSelected:{type:"string"},stackCategory:{type:"string"},svgClassName:{type:"string"},svgStyle:{type:"object"},type:{type:"string",enumValues:["area","auto","bar","boxPlot","candlestick","line","lineWithArea"],value:"auto"}},extension:{}};!function(){u.extension._CONSTRUCTOR=function(){};e.CustomElementBridge.register("oj-chart-series",{metadata:u,parseFunction:t.shapeParseFunction({"marker-shape":!0},{square:!0,circle:!0,diamond:!0,plus:!0,triangleDown:!0,triangleUp:!0,human:!0,star:!0,auto:!0})})}();var y={properties:{drilling:{type:"string",enumValues:["inherit","off","on"],value:"inherit"},labelStyle:{type:"object"},name:{type:"string"},shortDesc:{type:"string"}},extension:{}};y.extension._CONSTRUCTOR=function(){},e.CustomElementBridge.register("oj-chart-group",{metadata:y});var g={properties:{animationDuration:{type:"number"},animationOnDataChange:{type:"string",enumValues:["auto","none"],value:"none"},animationOnDisplay:{type:"string",enumValues:["auto","none"],value:"none"},areaColor:{type:"string",value:""},areaSvgClassName:{type:"string",value:""},areaSvgStyle:{type:"object",value:{}},as:{type:"string",value:""},barGapRatio:{type:"number",value:.25},baselineScaling:{type:"string",enumValues:["min","zero"],value:"min"},color:{type:"string"},data:{type:"object",extension:{webelement:{exceptionStatus:[{type:"deprecated",since:"11.0.0",description:"Data sets from a DataProvider cannot be sent to WebDriverJS; use ViewModels or page variables instead."}]}}},firstColor:{type:"string",value:""},highColor:{type:"string",value:""},items:{type:"Array<Object>|Array<number>|Promise"},lastColor:{type:"string",value:""},lineStyle:{type:"string",enumValues:["dashed","dotted","solid"],value:"solid"},lineType:{type:"string",enumValues:["centeredSegmented","centeredStepped","curved","none","segmented","stepped","straight"],value:"straight"},lineWidth:{type:"number",value:1},lowColor:{type:"string",value:""},markerShape:{type:"string",value:"auto"},markerSize:{type:"number",value:5},referenceObjects:{type:"Array<Object>",value:[]},svgClassName:{type:"string",value:""},svgStyle:{type:"object",value:{}},tooltip:{type:"object",properties:{renderer:{type:"function"}}},trackResize:{type:"string",enumValues:["off","on"],value:"on"},translations:{type:"object",value:{},properties:{componentName:{type:"string"},labelAndValue:{type:"string"},labelClearSelection:{type:"string"},labelCountWithTotal:{type:"string"},labelDataVisualization:{type:"string"},labelInvalidData:{type:"string"},labelNoData:{type:"string"},stateCollapsed:{type:"string"},stateDrillable:{type:"string"},stateExpanded:{type:"string"},stateHidden:{type:"string"},stateIsolated:{type:"string"},stateMaximized:{type:"string"},stateMinimized:{type:"string"},stateSelected:{type:"string"},stateUnselected:{type:"string"},stateVisible:{type:"string"}}},type:{type:"string",enumValues:["area","bar","line","lineWithArea"],value:"line"},visualEffects:{type:"string",enumValues:["auto","none"],value:"auto"}},methods:{getDataItem:{},getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};!function(){g.extension._WIDGET_NAME="ojSparkChart";e.CustomElementBridge.register("oj-spark-chart",{metadata:g,parseFunction:t.shapeParseFunction({"marker-shape":!0},{square:!0,circle:!0,diamond:!0,plus:!0,triangleDown:!0,triangleUp:!0,human:!0,star:!0,auto:!0})})}();var c={properties:{borderColor:{type:"string",value:""},color:{type:"string",value:""},date:{type:"string",value:""},high:{type:"number"},low:{type:"number"},markerDisplayed:{type:"string",enumValues:["off","on"],value:"off"},markerShape:{type:"string"},markerSize:{type:"number"},svgClassName:{type:"string",value:""},svgStyle:{type:"object",value:{}},value:{type:"number"}},extension:{}};c.extension._CONSTRUCTOR=function(){},e.CustomElementBridge.register("oj-spark-chart-item",{metadata:c});const d=(e,t,r,n)=>{const o=e.element[0],i=e._TemplateHandler,s=i.getTemplates(),l=s.seriesTemplate?s.seriesTemplate[0]:null,p=s.groupTemplate?s.groupTemplate[0]:null,u=e.options.seriesComparator,y=e.options.groupComparator,g=new Map,c=p||y?new Map:null,d=new Map,m=(e,a)=>{const s=[...e.keys()],l=new Map,u=s.map((s,u)=>{let g;const d=e.get(s),b=d.value,h=d.groups;let v;return(p||y)&&(v=((e,t,n,i)=>{const a={ids:t,componentElement:o,depth:t.length,leaf:i,index:n};return Object.defineProperty(a,"items",{get:()=>c.get(e).map(e=>{const t=r[e];return{data:t._itemData,key:t.id,index:e}})}),a})(b,[...a,s],u,!h),l.set(s,v)),g=p?i.processNodeTemplate(n,t,p,"oj-chart-group",v,b):{},g.id=s,g.name=null==g.name?s:g.name,h?g.groups=m(h,[...a,s]):Object.defineProperty(g,"symbol",{value:b,enumerable:!1}),g});return y&&u.sort((e,t)=>y(l.get(e.id),l.get(t.id))),u},b=e=>{const t=[];return e.forEach(e=>{e.groups?t.push(...b(e.groups)):t.push(e.symbol)}),t};r.forEach((e,t)=>{const r=(e=>{let t=g;const r=[];for(let n=0;n<e.length;n++){const o=e[n];let i=t.get(o);i||(i={value:Symbol(o)},n!==e.length-1&&(i.groups=new Map),t.set(o,i)),r.push(i.value),t=i.groups}return r})(e.groupId);((e,t,r)=>{let n=d.get(e);n||(n=new Map,d.set(e,n));const o=t[t.length-1];void 0===n.get(o)&&(n.set(o,r),c&&t.forEach(e=>{let t=c.get(e);t||(t=[],c.set(e,t)),t.push(r)}))})(e.seriesId,r,t)});const h=(()=>{try{return m(g,[])}catch(e){return a.error(e),[]}})();return{groups:h,series:(e=>{let s;try{const a=new Map,p=b(e);s=[...d.keys()].map((e,s)=>{const y=d.get(e);let g,c;return(l||u)&&(g=((e,t,n,i)=>{const a={componentElement:o,id:e,index:t};return Object.defineProperty(a,"items",{get:()=>{const e=[];return n.forEach(t=>{const n=i.get(t);if(null!=n){const t=r[n];e.push({data:t._itemData,key:t.id,index:n})}}),e}}),a})(e,s,p,y),a.set(e,g)),c=l?i.processNodeTemplate(n,t,l,"oj-chart-series",g,e):{},c.id=e,c.name=null==c.name?String(e):c.name,c.items=p.map(e=>{let t=null;const n=y.get(e);return null!=n&&(t=r[n]),t}),c}),u&&s.sort((e,t)=>u(a.get(e.id),a.get(t.id)))}catch(e){a.error(e),s=[]}return s})(h)}};e.__registerWidget("oj.ojChart",n.oj.dvtBaseComponent,{widgetEventPrefix:"oj",options:{data:null,series:null,groups:null,selectInput:null,tooltip:{renderer:null},viewportChange:null,viewportChangeInput:null,drill:null,itemDrill:null,groupDrill:null,seriesDrill:null,multiSeriesDrill:null},_ComponentCreate:function(){this._super(),this._SetLocaleHelpers(i,o)},_CreateDvtComponent:function(e,t,r){return new s.Chart(e,t,r)},_ConvertLocatorToSubId:function(e){var t=e.subId;return"oj-chart-item"===t?t="dataItem["+e.seriesIndex+"]["+e.itemIndex+"]":"oj-chart-group"===t?t="group"+this._GetStringFromIndexPath(e.indexPath):"oj-chart-series"===t?t="series["+e.index+"]":"oj-chart-axis-title"===t?t=e.axis+":title":"oj-chart-reference-object"===t?t=e.axis+":referenceObject["+e.index+"]":"oj-legend-item"===t?(t="legend:section"+this._GetStringFromIndexPath(e.sectionIndexPath),t+=":item["+e.itemIndex+"]"):"oj-chart-tooltip"===t?t="tooltip":"oj-chart-pie-center-label"===t&&(t="pieCenterLabel"),t},_ProcessTemplates:function(e,t,r,n,o,i,a){var s=i?this._TemplateHandler.getComponentResults(e):null;if(!s){var l=this._super(e,t,r,n,o,i,a),p=d(this,r,l.values[0],e);s={paths:["series","groups"],values:[p.series,p.groups]},i&&this._TemplateHandler.setComponentResults(e,s)}return s},_GetSimpleDataProviderConfigs:function(){return{data:{templateName:"itemTemplate",templateElementName:"oj-chart-item",resultPath:"_item",derivedTemplates:["seriesTemplate","groupTemplate"]}}},_UseObjectAssignForShapedData:function(){return!0},_ProcessOptions:function(){this._super();var e=this.options.pieCenter;e&&e._renderer&&(e.renderer=this._GetTemplateRenderer(e._renderer,"center"));var t=this.options.selection;this._IsCustomElement()&&t&&"object"==typeof t[0]&&!this.options.data&&(this.options.selection=null)},_ConvertSubIdToLocator:function(e){var t={};if(0===e.indexOf("dataItem")){var r=this._GetIndexPath(e);t.subId="oj-chart-item",t.seriesIndex=r[0],t.itemIndex=r[1]}else if(0===e.indexOf("group"))t.subId="oj-chart-group",t.indexPath=this._GetIndexPath(e);else if(0===e.indexOf("series"))t.subId="oj-chart-series",t.index=this._GetFirstIndex(e);else if(e.indexOf("Axis:title")>0)t.subId="oj-chart-axis-title",t.axis=e.substring(0,e.indexOf(":"));else if(e.indexOf("Axis:referenceObject")>0)t.subId="oj-chart-reference-object",t.axis=e.substring(0,e.indexOf(":")),t.index=this._GetFirstIndex(e);else if(0===e.indexOf("legend")){if(e.indexOf(":item")>0){var n=e.indexOf(":item"),o=e.substring(0,n),i=e.substring(n);t.subId="oj-legend-item",t.sectionIndexPath=this._GetIndexPath(o),t.itemIndex=this._GetFirstIndex(i)}}else"tooltip"===e?t.subId="oj-chart-tooltip":"pieCenterLabel"===e&&(t.subId="oj-chart-pie-center-label");return t},_GetComponentRendererOptions:function(){return[{path:"tooltip/renderer",slot:"tooltipTemplate"},{path:"pieCenter/renderer",slot:"pieCenterTemplate"}]},_GetComponentStyleClasses:function(){var e=this._super();return e.push("oj-chart"),e},_GetChildStyleClasses:function(){var e=this._super();return e["oj-chart-data-label"]={path:"styleDefaults/_dataLabelStyle",property:"TEXT"},e["oj-chart-data-cursor-line"]=[{path:"styleDefaults/dataCursor/lineColor",property:"color"},{path:"styleDefaults/dataCursor/lineWidth",property:"width"}],e["oj-chart-stack-label"]={path:"styleDefaults/stackLabelStyle",property:"TEXT"},e["oj-chart-pie-center-label"]={path:"pieCenter/labelStyle",property:"TEXT"},e["oj-chart-slice-label"]={path:"styleDefaults/sliceLabelStyle",property:"TEXT"},e["oj-chart-stock-falling"]={path:"styleDefaults/stockFallingColor",property:"background-color"},e["oj-chart-stock-range"]={path:"styleDefaults/stockRangeColor",property:"background-color"},e["oj-chart-stock-rising"]={path:"styleDefaults/stockRisingColor",property:"background-color"},e["oj-chart-xaxis-tick-label"]={path:"xAxis/tickLabel/style",property:"TEXT"},e["oj-chart-xaxis-title"]={path:"xAxis/titleStyle",property:"TEXT"},e["oj-chart-yaxis-tick-label"]={path:"yAxis/tickLabel/style",property:"TEXT"},e["oj-chart-yaxis-title"]={path:"yAxis/titleStyle",property:"TEXT"},e["oj-chart-y2axis-tick-label"]={path:"y2Axis/tickLabel/style",property:"TEXT"},e["oj-chart-y2axis-title"]={path:"y2Axis/titleStyle",property:"TEXT"},e["oj-chart-reference-object-line"]=[{path:"_defaultReferenceObjectLineColor",property:"color"},{path:"_defaultReferenceObjectLineWidth",property:"width"}],e["oj-chart-reference-object-area"]={path:"_defaultReferenceObjectAreaColor",property:"color"},e["oj-legend"]={path:"legend/textStyle",property:"TEXT"},e["oj-legend-title"]={path:"legend/titleStyle",property:"TEXT"},e["oj-legend-section-title"]={path:"legend/_sectionTitleStyle",property:"TEXT"},e["oj-legend-hover"]={path:"legend/_hoverBorderRadius",property:"border-radius"},e["oj-dvt-color-ramp"]={path:"styleDefaults/colors",property:"COLOR"},e},_GetEventTypes:function(){return["drill","groupDrill","itemDrill","seriesDrill","multiSeriesDrill","optionChange","selectInput","viewportChange","viewportChangeInput"]},_HandleEvent:function(e){var t=e.type;if("selection"===t){var r=e.selection;if(r){for(var n=[],o=[],i=0;i<r.length;i++){var a;a=this._IsCustomElement()?r[i].id:{id:r[i].id,series:r[i].series,group:r[i].group};var s={data:r[i].data,seriesData:r[i].seriesData,groupData:r[i].groupData,itemData:r[i].itemData};n.push(a),o.push(s)}var l={endGroup:e.endGroup,startGroup:e.startGroup,xMax:e.xMax,xMin:e.xMin,yMax:e.yMax,yMin:e.yMin,y2Max:e.y2Max,y2Min:e.y2Min,selectionData:o};this._IsCustomElement()||(l.component=e.component),e.complete?this._UserOptionChange("selection",n,l):(l.items=n,this._trigger("selectInput",null,l))}}else if("viewportChange"===t){var p={endGroup:e.endGroup,startGroup:e.startGroup,xMax:e.xMax,xMin:e.xMin,yMax:e.yMax,yMin:e.yMin};e.complete&&(this.options.xAxis||(this.options.xAxis={}),this.options.yAxis||(this.options.yAxis={}),this.options.xAxis.viewportStartGroup=null,this.options.xAxis.viewportEndGroup=null,null!=e.xMin&&null!=e.xMax&&(this.options.xAxis.viewportMin=e.xMin,this.options.xAxis.viewportMax=e.xMax),null!=e.yMin&&null!=e.yMax&&(this.options.yAxis.viewportMin=e.yMin,this.options.yAxis.viewportMax=e.yMax)),this._trigger(e.complete?"viewportChange":"viewportChangeInput",null,p)}else if("drill"===t)if(e.subType){if(this._IsCustomElement()){var u=e.subType;"item"===u?this._trigger("itemDrill",null,{id:e.id,series:e.series,group:e.group,data:e.data,itemData:e.itemData,seriesData:e.seriesData,groupData:e.groupData}):"group"===u?this._trigger("groupDrill",null,{group:e.group,groupData:e.groupData,id:e.id,items:e.items}):"series"===u?this._trigger("seriesDrill",null,{id:e.id,items:e.items,series:e.series,seriesData:e.seriesData}):"multiSeries"===u&&this._trigger("multiSeriesDrill",null,{items:e.items,series:e.series,seriesData:e.seriesData})}}else this._trigger("drill",null,{id:e.id,series:e.series,group:e.group,data:e.data,seriesData:e.seriesData,groupData:e.groupData,itemData:e.itemData,component:e.component});else this._super(e)},_LoadResources:function(){null==this.options._resources&&(this.options._resources={});var e=this.options._resources;e.overviewGrippy="oj-fwk-icon oj-fwk-icon-drag-horizontal",e.pan="oj-fwk-icon oj-fwk-icon-pan",e.select="oj-fwk-icon oj-fwk-icon-marquee",e.zoom="oj-fwk-icon oj-fwk-icon-magnifier"},getTitle:function(){return this._component.getAutomation().getTitle()},getGroup:function(e){return this._component.getAutomation().getGroup(e)},getSeries:function(e){return this._component.getAutomation().getSeries(e)},getGroupCount:function(){return this._component.getAutomation().getGroupCount()},getSeriesCount:function(){return this._component.getAutomation().getSeriesCount()},getDataItem:function(e,t){return this._component.getAutomation().getDataItem(e,t)},getLegend:function(){return this._component.getAutomation().getLegend()},getPlotArea:function(){return this._component.getAutomation().getPlotArea()},getXAxis:function(){return this._component.getAutomation().getXAxis()},getYAxis:function(){return this._component.getAutomation().getYAxis()},getY2Axis:function(){return this._component.getAutomation().getY2Axis()},getValuesAt:function(e,t){return this._component.getValsAt(e,t)},getContextByNode:function(e){var t=this.getSubIdByNode(e);return t&&"oj-chart-tooltip"!==t.subId?t:null},_GetComponentNoClonePaths:function(){var e=this._super();return e.pieCenter={converter:!0},e.xAxis={tickLabel:{converter:!0}},e.yAxis={tickLabel:{converter:!0}},e.y2Axis={tickLabel:{converter:!0}},e.valueFormats={close:{converter:!0},high:{converter:!0},label:{converter:!0},low:{converter:!0},open:{converter:!0},q1:{converter:!0},q2:{converter:!0},q3:{converter:!0},targetValue:{converter:!0},value:{converter:!0},volume:{converter:!0},x:{converter:!0},y:{converter:!0},y2:{converter:!0},z:{converter:!0}},e},_GetComponentDeferredDataPaths:function(){return{root:["groups","series","data"]}},_CompareOptionValues:function(t,r,n){return"dataCursorPosition"===t?e.Object.compareValues(r,n):this._super(t,r,n)}}),e.__registerWidget("oj.ojSparkChart",n.oj.dvtBaseComponent,{widgetEventPrefix:"oj",options:{as:"",data:null,items:null,referenceObjects:[],tooltip:{renderer:null},type:"line",color:"#267DB3",areaColor:"",areaSvgClassName:"",areaSvgStyle:{},svgClassName:"",svgStyle:{},firstColor:"",lastColor:"",highColor:"",lowColor:"",animationDuration:void 0,animationOnDataChange:"none",animationOnDisplay:"none",visualEffects:"auto",baselineScaling:"min",lineWidth:1,lineStyle:"solid",lineType:"straight",markerShape:"auto",markerSize:5,barGapRatio:.25},_CreateDvtComponent:function(e,t,r){return this._focusable({element:this.element,applyHighlight:!0}),new s.SparkChart(e,t,r)},_GetComponentStyleClasses:function(){var e=this._super();return e.push("oj-sparkchart"),e},_GetChildStyleClasses:function(){var e=this._super();return e["oj-dvtbase oj-sparkchart"]={path:"animationDuration",property:"ANIM_DUR"},e},_Render:function(){this.element.attr("title")?(this.options.shortDesc=this.element.attr("title"),this.element.data(this.element,"title",this.element.attr("title")),this.element.removeAttr("title")):this.element.data("title")&&(this.options.shortDesc=this.element.data("title")),this._super()},getDataItem:function(e){var t=this._component.getAutomation().getDataItem(e);return this._AddAutomationGetters(t),t&&(t.getFloatValue=t.getLow),t},_GetComponentDeferredDataPaths:function(){return{root:["items","data"]}},_GetSimpleDataProviderConfigs:function(){return{data:{templateName:"itemTemplate",templateElementName:"oj-spark-chart-item",resultPath:"items"}}},_AddAutomationGetters:function(e){if(e){for(var t={},r=Object.keys(e),n=0;n<r.length;n++)this._addGetter(e,r[n],t);Object.defineProperties(e,t)}},_addGetter:function(e,t,r){r[("selected"===t?"is":"get")+t.charAt(0).toUpperCase()+t.slice(1)]={value:function(){return e[t]}}}})});
//# sourceMappingURL=ojchart.js.map