/**
 * @license
 * Copyright (c) 2014, 2022, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcomponentcore","ojs/ojoption","ojs/ojdataprovider","ojs/ojcomposite"],function(e,t,i,o){"use strict";function s(e){this._composite=e.element,this._properties=e.properties,this.disconnected=this._disconnected.bind(this),this.connected=this._connected.bind(this),this.propertyChanged=this._propertyChanged.bind(this),this.optionIdPrefix=[e.unique,"opt"].join("_"),this.handleAction=this._handleAction.bind(this),this.handleOptionMutations=this._handleOptionMutations.bind(this),this._composite.setAttribute("role","group"),this._properties.disabled&&this._composite.setAttribute("aria-disabled","true")}s.prototype._connected=function(e){this._addEventListener()},s.prototype._disconnected=function(e){this._removeEventListener()},s.prototype._propertyChanged=function(e){("external"===e.updatedFrom&&"value"===e.property||"external"===e.updatedFrom&&"disabled"===e.property||"external"===e.updatedFrom&&"options"===e.property)&&(this._handleOptionMutations(),"disabled"===e.property&&(this._properties.disabled?this._composite.setAttribute("aria-disabled","true"):this._composite.removeAttribute("aria-disabled")))},s.prototype._addEventListener=function(){this._optionMutations=new MutationObserver(this.handleOptionMutations),this._optionMutations.observe(this._composite,{attributes:!0,subtree:!0,attributeFilter:["role"]}),this._composite.addEventListener("ojAction",this.handleAction,!0)},s.prototype._removeEventListener=function(){if(this._composite.removeEventListener("ojAction",this.handleAction,!0),this._optionMutations){var e=this._optionMutations.takeRecords();e&&e.length>0&&this.handleOptionMutations(),this._optionMutations.disconnect(),delete this._optionMutations}},s.prototype._handleAction=function(e){var t=e.target,i=t.value;s._optionToggleChecked(t)?this._addValue(i):this._removeValue(i)},s.prototype._handleOptionMutations=function(){for(var e=this._properties.value,t=this._composite.querySelectorAll("oj-option"),i=0;i<t.length;i++){var o=t[i];if(o.classList.contains("oj-menu-item")){var r=o.value,n=e.indexOf(r)>-1;s._optionSetChecked(o,n),this._properties.disabled?s._optionSetDisabled(o,!0):s._optionSetDisabled(o,o.disabled)}}},s.prototype._addValue=function(e){var t=this._properties.value;if(t.indexOf(e)<0){var i=t.slice();i.push(e),this._properties.value=i}},s.prototype._removeValue=function(e){var t=this._properties.value,i=t.indexOf(e);if(i>-1){var o=t.slice();o.splice(i,1),this._properties.value=o}},s._optionToggleChecked=function(e){var t=!1,i=e.firstChild;if(i){var o=i.querySelector(".oj-menucheckbox-icon");"true"===i.getAttribute("aria-checked")?(i.setAttribute("aria-checked","false"),o&&o.classList.remove("oj-selected")):(i.setAttribute("aria-checked","true"),o&&o.classList.add("oj-selected")),t="true"===i.getAttribute("aria-checked")}return t},s._optionSetChecked=function(e,t){var i=e.firstChild;if(i){i.setAttribute("aria-checked",t?"true":"false");var o=i.querySelector(".oj-menucheckbox-icon");o&&(t?o.classList.add("oj-selected"):o.classList.remove("oj-selected"))}},s._optionSetDisabled=function(e,t){var i=e.firstChild;if(i){var o=i.querySelector(".oj-menucheckbox-icon");t?(e.classList.add("oj-disabled"),i.setAttribute("aria-disabled","true"),o&&o.classList.add("oj-disabled")):(e.classList.remove("oj-disabled"),i.removeAttribute("aria-disabled"),o&&o.classList.remove("oj-disabled"))}};o.register("oj-menu-select-many",{view:'<oj-bind-slot></oj-bind-slot><oj-bind-if test="[[$properties.options]]">  <oj-bind-for-each data="[[$properties.options]]">    <template>      <oj-option :id="[[$current.data.id ? $current.data.id : optionIdPrefix + $current.observableIndex()]]"                  value="[[$current.data.value]]" disabled="[[$current.data.disabled]]">        <oj-bind-text value="[[$current.data.label]]"></oj-bind-text>      </oj-option>    </template>  </oj-bind-for-each><oj-bind-if>',viewModel:s,metadata:{properties:{disabled:{type:"boolean",value:!1},options:{type:"Array<Object>|object"},value:{type:"Array<any>",writeback:!0,value:[]}},methods:{getProperty:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}}})});
//# sourceMappingURL=ojmenuselectmany.js.map