/**
 * @license
 * Copyright (c) 2014, 2022, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","jquery","ojs/ojcontext","ojs/ojthemeutils","ojs/ojcomponentcore"],function(e,t,s,i,n){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;var r={properties:{selectedStep:{type:"string",writeback:!0},steps:{type:"Array<Object>"},translations:{type:"object",value:{}}},methods:{getNextSelectableStep:{},getPreviousSelectableStep:{},getProperty:{},getStep:{},refresh:{},setProperties:{},setProperty:{},updateStep:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojBeforeDeselect:{},ojBeforeSelect:{},ojDeselect:{},ojSelect:{}},extension:{}};r.extension._WIDGET_NAME="ojTrain",e.CustomElementBridge.register("oj-train",{metadata:r}),e.__registerWidget("oj.ojTrain",t.oj.baseComponent,{version:"1.0.0",defaultElement:"<div>",widgetEventPrefix:"oj",options:{steps:[],selected:"",selectedStep:"",beforeDeselect:null,deselect:null,beforeSelect:null,select:null},_stepNum:0,_stepArray:null,_ComponentCreate:function(){this._super(),this._setupTrain()},_setupTrain:function(){var e=this.options,s=e.steps;this._stepNum=s.length,this._wrapper=t("<div class='oj-train-wrapper'></div>"),this._wrapper.appendTo(this.element),this._connectorWrapper=t("<div class='oj-train-connector-wrapper'></div>"),this._connectorWrapper.appendTo(this._wrapper);var n=this.element.attr("class");this._stretch=null!=n&&n.indexOf("oj-train-stretch")>=0,this._stretch&&this._connectorWrapper.css("padding","0 "+100/(2*this._stepNum)+"%"),this._connector=t("<div class='oj-train-connector'></div>"),this._connector.appendTo(this._connectorWrapper),this._stepList=t("<ul>"),this._stepList.addClass("oj-train-step-list"),this._connectorFill=t("<div class='oj-train-connector-fill'></div>"),this._connectorFill.appendTo(this._connectorWrapper),this._setupArray(),this._selectedIndex=this._getStepIndex(e.selectedStep||e.selected),-1===this._selectedIndex&&s[0]&&s[0].id&&(this._selectedIndex=0,e.selectedStep=s[0].id,e.selected=s[0].id);for(var r=0;r<this._stepNum;r++){var a=this._stepArray[r][1],o=t("<li>").addClass("oj-train-step-list-item").attr({id:a}),d=this._stepArray[r][2];this._selectedIndex===r?o.addClass("oj-selected"):d&&o.addClass("oj-disabled");var l=this._stepArray[r][4];"confirmation"===l?o.addClass("oj-confirmation"):"info"===l?o.addClass("oj-info"):"error"===l||"fatal"===l?o.addClass("oj-invalid"):"warning"===l&&o.addClass("oj-warning"),o.appendTo(this._stepList),this._drawLabel(r),this._drawStepFill(r),this._drawIndividualConnectorLine(r),this._drawButton(r),this._drawStepNumberLabel(r),this._drawMessageType(r),this._stretch&&o.css("width",100/this._stepNum+"%"),i.parseJSONFromFontFamily("oj-theme-json").behavior.includes("redwood")&&!d&&this._selectedIndex!==r&&(this._AddHoverable(o),this._AddActiveable(o),o.on("click"+this.eventNamespace,this._preventDefaultAndFireSelectedStepOptionChange.bind(this,a)))}var p=this._stepNum-1===this._selectedIndex?100:100/(2*(this._stepNum-1))+this._selectedIndex/(this._stepNum-1)*100;this._connectorFill.css({width:p+"%"}),this._stepList.appendTo(this._wrapper),this.element.addClass("oj-train")},_preventDefaultAndFireSelectedStepOptionChange(e,s){s.keyCode!==t.ui.keyCode.ENTER&&"click"!==s.type||(s.preventDefault(),this._fireSelectedStepOptionChange(e,s))},_setupArray:function(){var e=this.options;this._stepArray=[];for(var t=0;t<this._stepNum;t++){var s=e.steps[t];this._stepArray[t]=[],this._stepArray[t][0]=s.label?s.label:null,this._stepArray[t][1]=s.id?s.id:null,this._stepArray[t][2]=!!s.disabled,this._stepArray[t][3]=!!s.visited,this._stepArray[t][4]=s.messageType?s.messageType:null}},_newDivElement:()=>t("<div></div>"),_drawButton:function(e){var s=this._newDivElement().addClass("oj-train-button"),i=t("<span></span>"),n="";if(this._stepArray[e]){var r=this._stepArray[e][3],a=this._stepArray[e][2];if(this._selectedIndex===e?(s.addClass("oj-selected"),n=" current "):r&&!a?(s.addClass("oj-visited"),n=" visited "):r||a?s.addClass("oj-disabled"):(s.addClass("oj-default"),n=" not visited "),!this._stepArray[e][2]&&this._selectedIndex!==e){this._AddHoverable(s),this._AddActiveable(s);var o=this._stepArray[e][1];s.on("click"+this.eventNamespace,function(e,t){this._fireSelectedStepOptionChange(e,t)}.bind(this,o))}var d=this._stepList.children().eq(e).find(".oj-train-button-connector");d.length>=1?(d.children().remove(),d.append(s)):d.append(s),i.text(n),i.addClass("oj-helper-hidden-accessible"),this._stepList.children().eq(e).find("a").append(i)}},_drawMessageType:function(e){if(this._stepArray[e]&&this._stepArray[e][4]){var s=this._newDivElement().addClass("oj-train-icon oj-component-icon").attr("aria-hidden","true"),i=t("<span></span>"),n="",r=this._stepArray[e][4];"confirmation"===r?(s.addClass("oj-confirmation"),n=" Confirmation "):"info"===r?(s.addClass("oj-info"),n=" Info "):"error"===r||"fatal"===r?(s.addClass("oj-error"),n=" Error "):"warning"===r&&(s.addClass("oj-warning"),n=" Warning ");var a=this._stepList.children().eq(e).find(".oj-train-button");if(a.children().length>=2&&a.children()[1].remove(),!this._stepArray[e][2]&&this._selectedIndex!==e){var o=this._stepArray[e][1];s.on("click"+this.eventNamespace,function(e,t){this._fireSelectedStepOptionChange(e,t)}.bind(this,o))}null!=r&&(i.text(n),i.addClass("oj-helper-hidden-accessible"),this._stepList.children().eq(e).find("a").append(i),a.append(s))}},_fireOptionChange:function(e,t,s){var i={fromStep:this.getStep(e),toStep:this.getStep(t),optionMetadata:{writeback:s?"shouldWrite":"shouldNotWrite"}};if(!1!==this._trigger("beforeDeselect",s,i)&&!1!==this._trigger("beforeSelect",s,i)){var n=this._getStepIndex(e);if(-1!==n){var r=this.options.steps[n];this._previousStepIndex=n,r.visited=!0,this._optionChangePrevented=!1}this._trigger("deselect",s,i),this.options.selectedStep&&this.option("selectedStep",t,{_context:{originalEvent:s,internalSet:!0}}),this.options.selected&&this.option("selected",t,{_context:{originalEvent:s,internalSet:!0}}),this._trigger("select",s,i)}else this._optionChangePrevented=!0},_drawStepNumberLabel:function(e){var t=this._newDivElement().addClass("oj-train-button-text");t.append((e+1).toString()),this._stepList.children().eq(e).find(".oj-train-button").append(t)},_drawIndividualConnectorLine:function(e){if(e!==this._stepNum-1){var t=this._newDivElement().addClass("oj-train-step-individual-connector");e<this._selectedIndex&&t.addClass("oj-train-connector-before-selected-step"),this._stepList.children().eq(e).prepend(t)}},_drawStepFill:function(e){var t=this._newDivElement();if(t.addClass("oj-train-button-connector"),this._stepArray[e]){e<=this._selectedIndex&&t.addClass("oj-train-fill");var s=this._stepList.children().eq(e).children();t.insertBefore(s)}},_drawLabel:function(e){if(this._stepArray[e]){var s=this._newDivElement().addClass("oj-train-label-wrapper"),i=t("<a>");i.text(this._stepArray[e][0]);var n=this._stepArray[e][2];if(s.append(i),i.addClass("oj-train-label"),e===this._selectedIndex?i.addClass("oj-selected"):this._stepArray[e][3]&&!n?i.addClass("oj-visited"):n&&(i.addClass("oj-disabled"),i.attr("aria-disabled","true")),!n){i.attr("href","#"),this._focusable({element:i,applyHighlight:!0}),this._AddHoverable(i),this._AddActiveable(i);var r=this._stepArray[e][1];i.on("click keydown"+this.eventNamespace,this._preventDefaultAndFireSelectedStepOptionChange.bind(this,r))}var a=this._stepList.children().eq(e).children();a.length>=2&&a[1].remove(),this._stepList.children().eq(e).append(s)}},_getStepIndex:function(e){for(var t=0;t<this._stepNum;t++)if(this._stepArray[t]&&this._stepArray[t][1]===e)return t;return-1},getStep:function(e){for(var s=0;s<this._stepNum;s++)if(this._stepArray[s]&&this._stepArray[s][1]===e)return t.extend({},this.options.steps[s]);return null},nextSelectableStep:function(){return this.getNextSelectableStep()},previousSelectableStep:function(){return this.getPreviousSelectableStep()},getNextSelectableStep:function(){for(var e=this._getStepIndex(this.options.selectedStep||this.options.selected);e<this._stepNum;e++)if(e+1<this._stepNum&&this._stepArray[e+1]&&!this._stepArray[e+1][2])return this._stepArray[e+1][1];return null},getPreviousSelectableStep:function(){for(var e=this._getStepIndex(this.options.selectedStep||this.options.selected);e>=0;e--)if(this._stepArray[e-1]&&!this._stepArray[e-1][2])return this._stepArray[e-1][1];return null},setStep:function(e){e.id&&this.updateStep(e.id,e)},updateStep:function(e,t){if(e){var s=this.getStep(e),i=this._getStepIndex(e);if(-1!==i){var n=this.options.steps[i];t.label&&(s[0]=t.label,n.label=t.label),"string"==typeof t.id&&(s[1]=t.id,n.id=t.id),"boolean"==typeof t.disabled&&(s[2]=t.disabled,n.disabled=t.disabled),"boolean"==typeof t.visited&&(s[3]=t.visited,n.visited=t.visited),("string"==typeof t.messageType||null!=n.messageType&&null===t.messageType)&&(s[4]=t.messageType,n.messageType=t.messageType),this.refresh()}}},_setOptions:function(e){this._super(e),this.refresh()},_setOption:function(e,t,s){if(("selectedStep"===e||"selected"===e)&&this._stepArray&&this._stepArray[this._selectedIndex]){if(t===this._stepArray[this._selectedIndex][1])return;this._fireOptionChange(this._stepArray[this._selectedIndex][1],t,null)}else this._super(e,t,s)},_busyContextAnimatingDescription:e=>e+"' is animating.",refresh:function(){var e,i;this._super(),this._destroy(),this._setupTrain(),null!=this._previousStepIndex&&null!=this._stepArray[this._previousStepIndex]&&(e=this._stepArray[this._previousStepIndex][4]),null!=this._selectedIndex&&null!=this._stepArray[this._selectedIndex]&&(i=this._stepArray[this._selectedIndex][4]);var n=this.getNodeBySubId({subId:"oj-train-step",index:this._selectedIndex});if(n&&null==i){var r=s.getContext(n).getBusyContext();n.classList.add("oj-train-button-selected-animation");var a=parseFloat(t(n).css("animationDuration"));if(a>0){var o=r.addBusyState({description:this._busyContextAnimatingDescription("The train selected button index='"+this._selectedIndex)});setTimeout(function(){o()},a)}}var d=this.getNodeBySubId({subId:"oj-train-step",index:this._previousStepIndex});if(d&&null==e){var l=s.getContext(d).getBusyContext();d.classList.add("oj-train-button-visited-animation");var p=parseFloat(t(d).css("animationDuration"));if(p>0){var h=l.addBusyState({description:this._busyContextAnimatingDescription("The train visited button index='"+this._previousStepIndex)});setTimeout(function(){h()},p)}}var c=this._stepList.children().eq(this._previousStepIndex).find(".oj-train-icon")[0];if(c){var _=s.getContext(c).getBusyContext();c.classList.add("oj-train-button-messaging-icon-animation");var u=parseFloat(t(c).css("animationDuration"));if(u>0){var f=_.addBusyState({description:this._busyContextAnimatingDescription("The train icon index='"+this._previousStepIndex)});setTimeout(function(){f()},u)}}var v=this._stepList.children().eq(this._selectedIndex).find(".oj-train-icon")[0];if(v){var y=s.getContext(v).getBusyContext();v.classList.add("oj-train-button-messaging-icon-animation");var g=parseFloat(t(v).css("animationDuration"));if(g>0){var b=y.addBusyState({description:this._busyContextAnimatingDescription("The train icon index='"+this._selectedIndex)});setTimeout(function(){b()},g)}}},_destroy:function(){this._stepList.children().each(function(){t(this).remove()}),this.element.removeClass("oj-train"),this.element.find(".oj-train-wrapper").remove(),this.element.find(".oj-train-connector-wrapper").remove(),this.element.find(".oj-train-step-list").remove(),this.element.find(".oj-train-step-list").remove(),this._super()},_fireSelectedStepOptionChange:function(e,t){var s=this._stepArray[this._selectedIndex][1];s!==e&&(this._fireOptionChange(s,e,t),this._optionChangePrevented||(this.refresh(),this._setFocus(e))),t.stopPropagation()},_setFocus:function(e){var t=this._getStepIndex(e);this._stepList.children().eq(t).find(".oj-train-label").focus()},getNodeBySubId:function(e){if(null===e)return this.element?this.element[0]:null;var t=e.subId,s=e.index;if("number"!=typeof s||s<0||s>=this._stepNum)return null;switch(t){case"oj-train-step":case"oj-train-button":return this._stepList.children().eq(s).find(".oj-train-button")[0];case"oj-train-button-connector":return this._stepList.children().eq(s).find(".oj-train-button-connector")[0];case"oj-train-connector":return this._connector;case"oj-train-connector-fill":return this._connectorFill;case"oj-train-icon":return this._stepList.children().eq(s).find(".oj-train-icon")[0];case"oj-train-label":return this._stepList.children().eq(s).find(".oj-train-label")[0];default:return null}},getSubIdByNode:function(e){for(var s=e,i=this._stepArray?this._stepArray.length:0,n=0;n<i;n++){var r={subId:"oj-train-step",index:n},a=this.getNodeBySubId(r);if(t(s).closest(a).length>0||t(s).closest(t(a.parentNode.parentNode).find(".oj-train-label")[0]).length>0)return r}return null}})});
//# sourceMappingURL=ojtrain.js.map