/**
 * Copyright (c) 2017, Oracle and/or its affiliates.
 * All rights reserved.
 */

define(["require","../persistenceUtils","../persistenceStoreManager","./defaultCacheHandler","./logger"],(function(e,n,t,r,o){"use strict";function s(e,n,t){Object.defineProperty(this,"_eventListeners",{value:[],writable:!0}),Object.defineProperty(this,"_isOnline",{value:e}),Object.defineProperty(this,"_browserFetch",{value:n}),Object.defineProperty(this,"_cache",{value:t})}function i(e){return"stop"===(e=e||{}).action}function u(e,n){var r,o,s,i,u,c=[];e instanceof Array||(e=[e]);var l=e.length,f=function(a){if(!(a<l))return Promise.resolve();if(s=e[a].storeName,o=e[a].operation,i=e[a].undoRedoData,"upsert"==o||"remove"==o&&n){for(c=[],u=i.length,r=0;r<u;r++)n?c.push({key:i[r].key,value:i[r].undo}):c.push({key:i[r].key,value:i[r].redo});return t.openStore(s).then((function(e){return 1==c.length&&null==c[0].value&&null!=c[0].key?e.removeByKey(c[0].key).then((function(){return f(++a)})):e.upsertAll(c).then((function(){return f(++a)}))}))}return"remove"==o?t.openStore(s).then((function(e){return e.removeByKey(i[0].key).then((function(){return f(++a)}))})):void 0};return f(0)}function c(e,n,t,r){var o=e._eventListeners.filter(function(e,n){return function(t){return e.toLowerCase()==t.type&&(null!=n&&n.match(t.scope)||null==n||null==t.scope)}}(n,r));return l(t,o)}function l(e,n){return n.length>0?n[0].listener(e).then((function(e){return null!=e?Promise.resolve(e):n.length>1?l(n.slice(1)):void 0})):Promise.resolve(null)}function f(e){return t.openStore(e,{index:["key"],skipMetadata:!0})}function a(){return f("syncLog")}function h(){return f("redoUndoLog")}return s.prototype.addEventListener=function(e,n,t){o.log("Offline Persistence Toolkit PersistenceSyncManager: addEventListener() for type: "+e+" and scope: "+t),this._eventListeners.push({type:e.toLowerCase(),listener:n,scope:t})},s.prototype.removeEventListener=function(e,n,t){o.log("Offline Persistence Toolkit PersistenceSyncManager: removeEventListener() for type: "+e+" and scope: "+t),this._eventListeners=this._eventListeners.filter((function(r){return e.toLowerCase()!=r.type||n!=r.listener||t!=r.scope}))},s.prototype.getSyncLog=function(){var e;return o.log("Offline Persistence Toolkit PersistenceSyncManager: getSyncLog()"),this._readingSyncLog||(this._readingSyncLog=(e=this,a().then((function(e){return e.find((n={},t=[],(r=[]).push("key"),n.sort=r,t.push("key"),t.push("value"),n.fields=t,n));var n,t,r})).then((function(e){return function(e){var t,r,o=[],s=function(e){return e&&0!=e.length?(t=e[0].key,r=e[0].value,n.requestFromJSON(r).then((function(n){return o.push(function(e,n){return{requestId:e,request:n,undo:function(){return function(e){return h().then((function(n){return n.findByKey(e)})).then((function(e){return null!=e&&u(e,!0).then((function(){return!0}))}))}(e)},redo:function(){return function(e){return h().then((function(n){return n.findByKey(e)})).then((function(e){return null!=e&&u(e,!1).then((function(){return!0}))}))}(e)}}}(t,n)),e.shift(),s(e)}))):Promise.resolve(o)};return s(e)}(e)})).then((function(n){return e._readingSyncLog=null,n})))),this._readingSyncLog},s.prototype.insertRequest=function(e,t){o.log("Offline Persistence Toolkit PersistenceSyncManager: insertRequest() for Request with url: "+e.url);var s={};return a().then((function(t){return s.store=t,n.requestToJSON(e,{_noClone:!0})})).then((function(n){return s.requestData=n,s.metadata=r.constructMetadata(e),s.requestId=s.metadata.created.toString(),s.store.upsert(s.requestId,s.metadata,s.requestData)})).then((function(){if(null!=t){var e=t.undoRedoDataArray;return null!=e?h().then((function(n){var t=function(r){return r<e.length&&null!=e[r]?n.upsert(s.requestId,s.metadata,e[r]).then((function(){return t(++r)})):Promise.resolve()};return t(0)})):Promise.resolve()}return Promise.resolve()}))},s.prototype.removeRequest=function(e){o.log("Offline Persistence Toolkit PersistenceSyncManager: removeRequest() for Request with requestId: "+e);var t=this,r={};return a().then((function(t){return r.store=t,function(e,t){return t.findByKey(e).then((function(e){if(e)return n.requestFromJSON(e)}))}(e,t)})).then((function(n){return n?t._internalRemoveRequest(e,n,r.store):void 0}))},s.prototype._internalRemoveRequest=function(e,n,t){var r=[];return t?r.push(t.removeByKey(e)):r.push(a().then((function(n){return n.removeByKey(e)}))),"GET"!==n.method&&"HEAD"!==n.method&&r.push(h().then((function(n){return n.removeByKey(e)}))),Promise.all(r).then((function(){return n})).catch((function(n){o.log("Offline Persistence Toolkit PersistenceSyncManager: removeRequest() error for Request with requestId: "+e)}))},s.prototype.updateRequest=function(e,t){return o.log("Offline Persistence Toolkit PersistenceSyncManager: updateRequest() for Request with requestId: "+e),Promise.all([a(),n.requestToJSON(t)]).then((function(n){var o=n[0],s=n[1],i=r.constructMetadata(t);return o.upsert(e,i,s)}))},s.prototype.sync=function(e){o.log("Offline Persistence Toolkit PersistenceSyncManager: sync()"),this._options=e||{};var t=this;return this._syncing?Promise.reject("Cannot start sync while sync is in progress"):(this._syncing=!0,new Promise((function(e,r){t.getSyncLog().then((function(s){var u,l,f;o.log("Offline Persistence Toolkit PersistenceSyncManager: Processing sync");var a=function(s){0==s.length&&(o.log("Offline Persistence Toolkit PersistenceSyncManager: Sync finished, no requests in sync log"),e()),s.length>0&&(o.log("Offline Persistence Toolkit PersistenceSyncManager: Processing sync, # of requests in sync log: "+s.length),u=s[0].requestId,l=s[0].request,f=l.clone(),o.log("Offline Persistence Toolkit PersistenceSyncManager: Dispatching beforeSyncRequest event"),c(t,"beforeSyncRequest",{requestId:u,request:f.clone()},l.url).then((function(h){if(i(h))return o.log("Offline Persistence Toolkit PersistenceSyncManager: Sync stopped by beforeSyncRequest event listener"),void e();"skip"!==(h=h||{}).action?("replay"===h.action&&(o.log("Offline Persistence Toolkit PersistenceSyncManager: Replay request from beforeSyncRequest event listener"),l=h.request),f=l.clone(),function(e,n){var t,r=e,s=r._options.preflightOptionsRequest,i=r._options.preflightOptionsRequestTimeout;if(null!=n.url&&"disabled"!=s&&null!=n.url.match(s)){if(o.log("Offline Persistence Toolkit PersistenceSyncManager: Checking URL based on preflightOptionsRequest"),r._pingedURLs){if(r._pingedURLs.indexOf(n.url)>=0)return Promise.resolve(!0)}else r._pingedURLs=[];return r._preflightOptionsRequestId=(new Date).getTime(),new Promise((t=r._preflightOptionsRequestId,function(e,o){r._repliedOptionsRequest=!1;var s=new Request(n.url,{method:"OPTIONS"}),u=6e4;null!=i&&(u=i),setTimeout((function(){r._repliedOptionsRequest||r._preflightOptionsRequestId!=t||o(!1)}),u),r._browserFetch(s).then((function(t){r._repliedOptionsRequest=!0,r._pingedURLs||(r._pingedURLs=[]),r._pingedURLs.push(n.url),e(!0)}),(function(n){r._repliedOptionsRequest=!0,e(!0)}))}))}return Promise.resolve(!0)}(t,l).then((function(){n.markReplayRequest(l,!0),o.log("Offline Persistence Toolkit PersistenceSyncManager: Replaying request with url: "+l.url),("undefined"!=typeof window&&null!=window?fetch:t._browserFetch)(l).then((function(h){h.status>=400?r({error:h.statusText,requestId:u,request:f.clone(),response:h.clone()}):n._cloneResponse(h,{url:l.url}).then((function(n){o.log("Offline Persistence Toolkit PersistenceSyncManager: Dispatching syncRequest event"),c(t,"syncRequest",{requestId:u,request:f.clone(),response:n.clone()},l.url).then((function(n){i(n)?e():(o.log("Offline Persistence Toolkit PersistenceSyncManager: Removing replayed request"),t._internalRemoveRequest(u,l).then((function(){s.shift(),a(s)}),(function(e){r({error:e,requestId:u,request:f.clone()})})))}))}))}),(function(e){r({error:e,requestId:u,request:f.clone()})}))}),(function(e){r(!1===e?{error:"Preflight OPTIONS request timed out",requestId:u,request:f.clone(),response:new Response(null,{status:504,statusText:"Preflight OPTIONS request timed out"})}:{error:e,requestId:u,request:f.clone()})}))):(o.log("Offline Persistence Toolkit PersistenceSyncManager: Removing skipped request"),t._internalRemoveRequest(u,l).then((function(){s.shift(),a(s)}),(function(e){r({error:e,requestId:u,request:f.clone()})})))})))};s=function(e){if(e&&e.length>0){var n,t,r=[];for(n=0;n<e.length;n++)"GET"!=(t=e[n].request).method&&"HEAD"!=t.method&&r.push(e[n]);for(n=0;n<e.length;n++)"GET"!=(t=e[n].request).method&&"HEAD"!=t.method||r.push(e[n]);return r}return e}(s),a(s)}))})).finally((function(e){t._syncing=!1,t._pingedURLs=null})))},s}));